---
title: XRSession.onsqueezestart
slug: Web/API/XRSession/onsqueezestart
tags:
  - API
  - AR
  - Event Handler
  - Mixed
  - Primary Squeeze Actions
  - Reality
  - Reference
  - Squeeze Actions
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRSession
  - actions
  - augmented
  - onsqueezestart
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_Header}}</p>

<p><span class="seoSummary">The {{domxref("XRSession")}} interface's <code><strong>onsqueezestart</strong></code> event handler property can be set to a function which is then invoked to handle the {{domxref("XRSession.squeezestart_event", "squeezestart")}} event that's sent when the user successfully begins a <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs#Primary_squeeze_actions">primary squeeze action</a> on a WebXR input device.</span> These actions represent the user squeezing or tightly gripping an object or controller.</p>

<p>To learn more about how to use and handle WebXR controller inputs, see <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>xrSession</em>.onsqueezestart = <em>squeezestartHandlerFunction</em>;</pre>

<h3 id="Value">Value</h3>

<p>A function to be invoked whenever the {{domxref("XRSession")}} receives a {{domxref("XRSession.squeezestart_event", "squeezestart")}} event.</p>

<h2 id="Examples">Examples</h2>

<p>This snippet of code adds a simple handler for the <code>squeezestart</code> event, which responds only to events on the user's dominant hand by getting the target ray, then calling a function <code>findObjectUsingRay()</code> to identify the object that the user is pointing at. This object is then stored in a <code>heldObject</code> variable in the <code>user</code> object we're using to represent user information.</p>

<pre class="brush: js">xrSession.onsqueezestart = event =&gt; {
  if (event.inputSource.handedness == user.handedness) {
    let targetRayPose = event.frame.getPose(event.inputSource.targetRaySpace, myRefSpace;

    if (targetRayPose) {
      user.heldObject = findObjectUsingRay(targetRayPose.transform);
    }
  }
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrsession-onsqueezestart","XRSession.onsqueezestart")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRSession.onsqueezestart")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a></li>
 <li>The other <code>onsqueeze*</code> handlers: {{DOMxRef("XRSession.onsqueeze", "onsqueeze")}} and {{DOMxRef("XRSession.onsqueezeend", "onsqueezeend")}}</li>
 <li>The {{domxref("XRSession.squeeze_event", "squeeze")}}, {{domxref("XRSession.squeezestart_event", "squeezestart")}}, and {{domxref("XRSession.squeezeend_event", "squeezeend")}} events</li>
</ul>
